<?php
/*
Plugin Name: Brander
Plugin URI: https://www.Videosocials.net/Brander
Description:Posts videos & articles as blog posts automatically from Brander dashboard.
Version: 1.1
Author: Videosocials
Author URI: https://www.Videosocials.net/Brander
Text Domain: Brander
Originally developed for the - Videosocials
*/

defined( 'ABSPATH' ) or die( 'No script kiddies please!' );


/*Firstly creating Database for the plugin*/
function bvs_plugin_create_db () {

    global $wpdb;
    $charset_collate = $wpdb->get_charset_collate();

    $table_name = $wpdb->prefix . 'bvs_contacts';
    
    $sql = "CREATE TABLE $table_name (
        Id MEDIUMINT(9) NOT NULL AUTO_INCREMENT,
        Created_Date DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
        Post_Id MEDIUMINT(9) NOT NULL,
        First_Name VARCHAR(255) NOT NULL,
        Last_Name VARCHAR(255) NOT NULL,
        Email VARCHAR(255) NOT NULL,
        Zip_Code VARCHAR(255) NOT NULL,
        PRIMARY KEY (Id)
    ) $charset_collate;";

    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

    dbDelta($sql);
}

register_activation_hook( __FILE__, 'bvs_plugin_create_db' );

/**
 * Register a custom menu page.
 */
add_action('admin_menu', 'admin_menu');

function admin_menu() {

add_menu_page(
        __( 'Videosocials', 'textdomain' ),  //Page title
        'Videosocials',                      //menu title
        'manage_options',                     //Capability
        'bvs_submenu',                        //menu slug
        'bvs_dashboard',                       //calback function
        plugins_url( 'brander_video_socials/images/mail-icons.png'), //icon url
        6                                     //position
    );

add_submenu_page( 'bvs_submenu', 'Posted Videos', '',
    'manage_options', 'bvs_submenu' );




add_submenu_page(
        'bvs_submenu',
        __( 'Contact List', 'textdomain' ),
        __( 'Contact List', 'textdomain' ),
        'manage_options',
        'bvs_contacts',
        'bvs_contacts'
    );

add_submenu_page(
        'bvs_submenu',
        __( 'Posted Videos', 'textdomain' ),
        __( 'Posted Videos', 'textdomain' ),
        'manage_options',
        'bvs_dashboard',
        'bvs_dashboard'
    );

}

add_action("admin_init", "download_csv");

function download_csv() { 
    ob_start();
    include_once plugin_dir_path( __FILE__ ).'export.php';
    $template = ob_get_contents();
    ob_end_clean();
    echo "$template";
 }

function bvs_settings() { 
   ob_start();
   include_once plugin_dir_path( __FILE__ ).'settings.php';
   $template = ob_get_contents();
   ob_end_clean();
   echo "$template";
}

function bvs_contacts() { 
   ob_start();
   include_once plugin_dir_path( __FILE__ ).'contact_list.php';
   $template = ob_get_contents();
   ob_end_clean();
   echo "$template";
}

function bvs_dashboard() { 
   ob_start();
   include_once plugin_dir_path( __FILE__ ).'post_list.php';
   $template = ob_get_contents();
   ob_end_clean();
   echo "$template";
}


//  REGISTER CUSTOM END POINT TO CREATE NEW POST (start) //
add_action('rest_api_init', function () {
    register_rest_route( '/brander-video-socials/v2', '/posts', array(
        'methods' => 'POST',
        'callback' => 'create_new_post'
        //'permission_callback' => 'check_access'
    ));
});


function rest_get_post_field( $post, $field_name, $request ) {
    return get_post_meta( $post[ 'id' ], $field_name, true );
}

function create_new_post($req) {

    $api_key = 'dmJzYXBpa2V5';

    global $wp_embed, $wpdb;

    $request_header = $req->get_header('vbs-api-key');
    
    // CHECK IF REQUEST IS AUTHENTICATED OR NOT (start) //
    if($request_header !== null && $request_header == $api_key){

        $post_title   = $req['post_title']; 
        $post_desc    = $req['post_content'];
        $post_video   = $req['post_video'];
        $email_intro_text   = $req['email_intro_text'];
        $post_status  = "publish";
        $post_author   = $req['author'];
        $post_date    = date('Y-m-d H:i:s');
        $post_type    = "post";

        $postVideo = '[embed]'.$post_video.'[/embed]';

        $post_content = "<p>" . $postVideo . "</p><p>" . $email_intro_text . "</p><p>" . '[contactpost]' . "</p><p>" . $post_desc ."</p>";
        $queryuser= $wpdb->get_row("SELECT u.ID FROM wp_users u INNER JOIN wp_usermeta m ON m.user_id = u.ID WHERE m.meta_key = 'wp_capabilities' AND m.meta_value LIKE '%administrator%' ORDER BY u.user_registered LIMIT 0 ,1 ");
        $admin_id=$queryuser->ID;


          ####New User Creation Code#####
          if(!empty($req['author_name'])){
          $user_name=$req['author_name'];
         $user_id = username_exists( $user_name );
         
         if(!empty($user_id)){
            $author_id = $user_id;
         }else{
            //dynamic admin id
            $author_id=$admin_id;
         }

       
        }else{
            //dynamic admin id
            $author_id=$admin_id;
            
        }



          ###User Creation Code Ends Here####
        $query = $wpdb->prepare('SELECT ID FROM ' . $wpdb->posts . ' WHERE post_title = "'.$post_title.'" AND post_status = "'.$post_status.'"' );
        $wpdb->query( $query );

        if ( $wpdb->num_rows ) {
            $post_id = $wpdb->get_var( $query );
            $update_post = array(
              'ID'           => $post_id,
              'post_content' => $post_content,
              'post_author'   => $author_id,
              'post_date'    => date('Y-m-d H:i:s')
            );
         
            // Update the post into the database //
            wp_update_post( $update_post );

            //$response['message'] = "Post updated successfully !";

            $response = array(
                'message'   => "Post updated successfully !",
                'post_link' => get_post_permalink( $post_id, $post_title,'')
                
            );
        } else {
            $new_post = array(
                'post_title'   => $post_title,
                'post_content' => $post_content,
                'post_status'  => $post_status,
                'post_author'   => $author_id,
                'post_date'    => date('Y-m-d H:i:s'),
                'post_type'    => $post_type
            );

            $post_id = wp_insert_post($new_post);
            
         
            //ADD OUR CUSTOM FIELDS

            $shortcode = "[bvs pid='".$post_id."']";
            add_post_meta($post_id, 'post_shortcode', $shortcode, true);

            add_post_meta($post_id, 'post_added_via', "API", true);

            //$response['message'] = "Post created successfully !";

            $response = array(
                'message'   => "Post created successfully !",
                'post_link' => get_post_permalink( $post_id, $post_title,'')
                
            );
            
        }
####Featured Image Post####
if(!empty($req['featured_image'])){
// Add Featured Image to Post
$image_url        = $req['featured_image'];// Define the image URL here
$ext = pathinfo($image_url, PATHINFO_EXTENSION);//ext is "html"
$Imgname = $post_id.'.'.$ext;
$image_name       = $Imgname;
$upload_dir       = wp_upload_dir(); // Set upload folder
$image_data       = file_get_contents($image_url); // Get image data
$unique_file_name = wp_unique_filename( $upload_dir['path'], $image_name ); // Generate unique name
$filename         = basename( $unique_file_name ); // Create image file name

// Check folder permission and define file location
if( wp_mkdir_p( $upload_dir['path'] ) ) {
    $file = $upload_dir['path'] . '/' . $filename;
} else {
    $file = $upload_dir['basedir'] . '/' . $filename;
}

// Create the image  file on the server
file_put_contents( $file, $image_data );

// Check image file type
$wp_filetype = wp_check_filetype( $filename, null );

// Set attachment data
$attachment = array(
    'post_mime_type' => $wp_filetype['type'],
    'post_title'     => sanitize_file_name( $filename ),
    'post_content'   => '',
    'post_status'    => $post_status
);

// Create the attachment
$attach_id = wp_insert_attachment( $attachment, $file, $post_id );

// Include image.php
require_once(ABSPATH . 'wp-admin/includes/image.php');

// Define attachment metadata
$attach_data = wp_generate_attachment_metadata( $attach_id, $file );

// Assign metadata to attachment
wp_update_attachment_metadata( $attach_id, $attach_data );

// And finally assign featured image to post
set_post_thumbnail($post_id, $attach_id );

}
####Featured Image Post End Here

 ##########Start Category Code #########
 if(!empty($req['category'])){
        
    $table_name="wp_terms";
    $tabletaxonomy="wp_term_taxonomy";  
    $tablettermrelation ='wp_term_relationships';

    $postcategory =explode(",",$req['category']);

    foreach($postcategory as $post_category){

    $querycat = $wpdb->prepare('SELECT term_id FROM ' . $table_name . ' WHERE name = "'.$post_category.'"' );
    $wpdb->query( $querycat );

    if ( $wpdb->num_rows ) {

        $term_id = $wpdb->get_var( $querycat );
        $updatepost = array(
            'term_id'=> $term_id,
            'name' => $post_category,
        );
     
        // Update the post into the database //
        wp_update_post( $updatepost );
        $termid=$term_id;

        ##Fetching Term_taxonomy_id####
        $querytaxonomy = $wpdb->get_row('SELECT term_taxonomy_id FROM ' . $tabletaxonomy . ' WHERE term_id = "'.$termid.'"' );
        
        $termtaxonomyid=$querytaxonomy->term_taxonomy_id;

        

    }else{
        $post_slug = preg_replace("/[\s_]/", "-", $post_category);
        $wpdb->insert( $table_name, array(
            'name' => $post_category,
            'slug' => strtolower($post_slug)
          ) );
          
          $termid = $wpdb->insert_id;
          
          
          $wpdb->insert( $tabletaxonomy, array(
            'taxonomy' => 'category',
            'term_id' => $termid,
            'parent' => '0'
          ) );
          $termtaxonomyid = $wpdb->insert_id;
    }

    wp_set_post_categories( $post_id, $termid, 'category');

    $wpdb->query( 'DELETE  FROM '.$tablettermrelation.' WHERE 
    term_taxonomy_id = "1" AND object_id = "'.$post_id.'"' );

}


    ##########END Category Code #########
}

###Tag Code Insertion Start here ####
if(!empty($req['tag'])){
    $post_tag = explode(",",$req['tag']);

    foreach ( $post_tag as $tag_value) {
        $post_tag_items[] =  $tag_value;
        }
        //create the final string to be posted using implode()
        $tagValue = implode (',', $post_tag_items);

        wp_set_post_tags( $post_id, $tagValue);

}


  ###Tag Code Ends here###      
        $response['ID'] = $post_id;

        $res = new WP_REST_Response($response);
        $res->set_status(200);

    }else{

        $response['message'] = "You do not have permissions to create data.";

        $res = new WP_REST_Response($response);
        $res->set_status(401);

    }

    // CHECK IF REQUEST IS AUTHENTICATED OR NOT (end) //


    return ['res' => $res];
}

// REGISTER CUSTOM END POINT TO CREATE NEW POST (end) //


// CONTACT FORM SHORTCODE //

define('BVSURL', WP_PLUGIN_URL."/".dirname( plugin_basename( __FILE__ ) ) );

function ajaxcontact_enqueuescripts(){
    wp_enqueue_script('ajaxcontact', BVSURL.'/js/ajaxform.js', array('jquery'));
    wp_localize_script( 'ajaxcontact', 'ajaxcontactajax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
}

add_action('wp_enqueue_scripts', 'ajaxcontact_enqueuescripts');

function ajaxcontact_show_contact(){

    global $post;

?>
    <form id="ajaxcontactform" name="ajaxcontactform" action="" method="post" enctype="multipart/form-data">
        <input type="hidden" name="ajax_post_id" id="ajax_post_id" value="<?php echo $post->ID; ?>">

        <div id="ajaxcontact-text">

            <div id="ajaxcontact-response" style="background-color:#E6E6FA ;color:blue;"><?php if(isset($results) && !empty($results)){ echo $results; } ?></div>

            <div>
                <!-- <strong>First Name <span style="color: red">*</span></strong> -->
                <input type="text" id="ajax_user_fname" name="ajax_user_fname" value="" required placeholder="First name"/>
                <input type="text" id="ajax_user_lname" name="ajax_user_lname" value="" required placeholder="Last name"/>
                <input type="text" id="ajax_user_email" name="ajax_user_email" value="" required placeholder="Email"/>
                <input type="text" id="ajax_user_zip" name="ajax_user_zip" value="" required placeholder="Zip code"/>
            </div>

            <div>
                <input type="button" class="submit_request" name="submit_request" value="Submit" onclick="ajaxformsendmail(ajax_post_id.value, ajax_user_fname.value, ajax_user_lname.value, ajax_user_email.value, ajax_user_zip.value);"/>
            </div>

        </div>
        <div><hr></div>
            <div><p><b>From the video...</b></p></div>
    </form>
<?php 

}



// creating Ajax call for WordPress

add_action( 'wp_ajax_nopriv_ajaxcontact_send_mail', 'ajaxcontact_send_mail' );
add_action( 'wp_ajax_ajaxcontact_send_mail', 'ajaxcontact_send_mail' );

function ajaxcontact_send_mail(){

    global $wpdb;
    $table_name = $wpdb->prefix.'bvs_contacts';

    $results = '';
    $error = 0;
    
    $postId = !empty($_POST['bvspostid']) ? $_POST['bvspostid'] : '';
    $fname  = !empty($_POST['bvsfname']) ? $_POST['bvsfname'] : '';
    $lname  = !empty($_POST['bvslname']) ? $_POST['bvslname'] : '';
    $email  = !empty($_POST['bvsemail']) ? $_POST['bvsemail'] : '';
    $zip    = !empty($_POST['bvszip']) ? $_POST['bvszip'] : '';

    $admin_email = get_option('admin_email');

    if (!filter_var($email, FILTER_VALIDATE_EMAIL)){
        $results = "Please enter valid email address !";
        $error = 1;
    }

    else if( strlen($fname) == 0 ){
        $results = "Please enter your first name !";
        $error = 1;
    }

    else if( strlen($lname) == 0 ){
        $results = "Please enter your last name !";
        $error = 1;
    }


    else if( strlen($email) == 0 ){
        $results = "Please enter your email address!";
        $error = 1;
    }

    else if( strlen($zip) == 0 ){
        $results = "Please enter your zip!";
        $error = 1;
    }

    
    if($error == 0){

        $addedDate = date("Y-m-d H:i:s");

        $addData = array('Post_Id' => $postId,'First_Name' => $fname, 'Last_Name' => $lname, 'Email' => $email, 'Zip_Code' => $zip, "Created_Date" => $addedDate);

        #####Send Email ###
      
       $to = get_option('admin_email'); 
       
        $subject = "New Request";

        $message = "
        <html>
        <head>
        <title>New Reuest</title>
        </head>
        <body>
        <p><b>Contact Information</b></p>
        <table width='100%' height=100' style='border-collapse:collapse' border='1px solid #dddddd'>
                <tr style='text-align: center;'>
                <th style='text-align: center;'>First Name</th>
                <th style='text-align: center;'>Last Name</th>
                <th style='text-align: center;'>Email</th>
                <th style='text-align: center;'>Zip</th>

            </tr>
                <tr style='background-color: #dddddd'>
                    <td style='text-align: center;'>".$fname."</td>
                    <td style='text-align: center;'>".$lname."</td>
                    <td style='text-align: center;'>".$email."</td>
                    <td style='text-align: center;'>".$zip."</td>
                </tr>
                </table>
        </body>
        </html>";
        
        
        // Always set content-type when sending HTML email
$headers  = "MIME-Version: 1.0" . "\r\n";
$headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
$headers .= "From:" . $email; 

    if(mail($to,$subject,$message,$headers)){
    $results = "Thanks for your interest. We will contact you soon!";
 }else{

    $results = "Mail Could Not Sent Try Again";
 }
 
        ############

     $wpdb->insert($table_name, $addData);
     
     
    }

    

    die($results);

}

function ajaxcontact_shortcode_func( $atts ){

    ob_start();
    ajaxcontact_show_contact();
    $output = ob_get_contents();
    ob_end_clean();
    return $output;

}

add_shortcode( 'contactpost', 'ajaxcontact_shortcode_func' );



// ADD SHORTCODE FOR POST //
add_shortcode('bvs', 'bvs_post_function');
function bvs_post_function($atts){

    if(!empty($atts['pid'])){

        $postId = $atts['pid'];
        $getPost = get_post( $postId );

    
        $postTitle   = "<h2>".$getPost->post_title."</h2>";
        $postContent = apply_filters('the_content', $getPost->post_content);

        $postData = $postTitle."\n".$postContent;

    }else{
        $postData = 'Looks like there is some problem. Please use shortcode carefully !';
    }

    return $postData;

}

?>
